import UIView from '@gec/ui-view';
export default class UIColFix extends UIView {
    constructor(customEl) {


        var element = _this.el; // || document.querySelector(".ui-colfix");
        /// element.insertAdjacentHTML('afterend', '</div">');
        //element.parentElement.classList.add("wrap-ui-colfix");
        /// element.parentElement.setAttribute('className', 'wrap-ui-colfix');
        //element.parentElement.className = "wrap-ui-colfix";
        //element.parentElement.className += "wrap-ui-colfix";
        //var wrapEl = document.querySelector(".wrap-ui-colfix");
        var child = element.getAttribute('data-child');
        var fixTo = element.getAttribute('data-fixto');
        var wrapEl = document.querySelector(fixTo) || element.parentElement;
        //references
        element.insertAdjacentHTML('beforebegin', '<i/>');
        // wrapEl.insertAdjacentHTML('afterbegin', '<div class="ref-top" ><div/>');
        //wrapEl.insertAdjacentHTML('beforeend', '<div class="ref-bottom"><div/>');
        //var prev = document.querySelector(".ref-top");
        var stickBottom = false;
        //var next = document.querySelector(".ref-bottom");
        var prev = element.previousElementSibling;
        //var prev = wrapEl.querySelector(".ref-top");

        //var next = wrapEl.querySelector(".ref-bottom");

        var previous = window.scrollY || 0;
        var ElmH = element.offsetHeight;
        var ParH = wrapEl.offsetHeight;
        var DSupBase = prev.getBoundingClientRect().top;
        var DInfBase = wrapEl.getBoundingClientRect().top + outerHeight(wrapEl) - (outerHeight(element));

        function outerHeight(elm) {
            var height = elm.offsetHeight;
            var style = getComputedStyle(elm);

            height += parseInt(style.marginTop) + parseInt(style.marginBottom);
            return height;
        }



        var elementDistance = function elementDistance() {

            var body = document.body,
                html = document.documentElement;

            var height = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);
            var VieH = screen.height;
            //var DSup = prev.getBoundingClientRect().top;
            //var DInf = next.getBoundingClientRect().top;

            var DocS = window.pageYOffset;
            var DocH = height;
            console.log("DSupBase : " + DSupBase);
            console.log("DInfBase : " + DInfBase);
            //console.log("DSup : " + DSup);
            //console.log("DInf : " + DInf);
            console.log("ElmH : " + ElmH);
            console.log("ParH : " + ParH);
            console.log("DocS : " + DocS);
            //console.log("VieH : " + VieH);
            //console.log("DocH : " + DocH);



            if (ParH - ElmH < 50) {
                element.style.top = '';
                element.classList.remove('ui-colfixed');
                element.classList.remove('ui-colabsoluted');
                return;
            }



            if (outerHeight(wrapEl) < outerHeight(element) || element.getAttribute('con') && (outerHeight(element) + outerHeight(element) / 2) > outerHeight(wrapEl)) {
                element.classList.remove('ui-colfixed');
                element.classList.remove('ui-colabsoluted');
                return false;
            }

            //e.data.itop = e.data.$i.offset().top;

            //e.data.ptop = e.data.$parent.offset().top + e.data.$parent.outerHeight(true) - (e.data.$element.outerHeight(true));

            var rest = stickBottom ? outerHeight(element) - VieH : 0;
            if (DocS > DSupBase + rest) {

                if (child) {
                    element.style.width = element.parentElement.offsetWidth + 'px';
                }

                if (DocS < DInfBase + rest) {
                    element.style.top = 0;
                    element.classList.add('ui-colfixed');
                    element.classList.remove('ui-colabsoluted');
                    element.style.top = (rest * -1) + 'px';
                } else {
                    element.style.top = DInfBase + 'px';
                    element.classList.add('ui-colabsoluted');
                    element.classList.remove('ui-colfixed');
                }

            } else {
                element.style.top = '';
                element.classList.remove('ui-colfixed');
                element.classList.remove('ui-colabsoluted');
                if (child) {
                    element.style.width = 'inherit';
                }
            }


            //parte superior
            /*if (DocS > DSupBase) {
                //Scroll > DSupBase : Alcanzo limite superior
                console.log("limite superior alcanzado: fixed");

                if (child) {
                    element.style.width = element.parentElement.offsetWidth + 'px';
                }
                element.style.top = '0';
                element.classList.add('ui-colfixed');
                element.classList.remove('ui-colabsoluted');



                if (DocS > (DSupBase + (ParH - ElmH))) {
                    if (ElmH > ParH) {
                        //Elemnt > Fixto : solo soltar!
                        if (DocS > (DSupBase + (ParH / 2))) {
                            console.log("soltar!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
                            element.style.top = '';
                            element.classList.remove('ui-colfixed');
                            element.classList.remove('ui-colabsoluted');
                        }

                    } else {
                        //Elemnt < Fixto : colocar en position absoluta!
                        console.log("absoluta!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
                        element.style.top = DSupBase + 'px';
                        element.classList.remove('ui-colfixed');
                        element.classList.add('ui-colabsoluted');
                    }
                }

                if (DocS > (DSupBase + ParH)) {
                    console.log("limite inferior alcanzado: soltar");
                    element.style.top = DSupBase + 'px';
                    element.classList.remove('ui-colfixed');
                    element.classList.remove('ui-colabsoluted');
                }

            } else {
                console.log("todavia...!!!!!");
                element.style.top = '';
                element.classList.remove('ui-colfixed');
                element.classList.remove('ui-colabsoluted');
            }*/

        };

        elementDistance();

        setTimeout(function() {

            window.onscroll = function() {
                elementDistance();
            };
        }, 300);

    }




}

exports.default = UIColFix;


UIColFix.dataSetName = 'UIColFix';

$.fn.UIColFix = function() {
    return this.each(function() {
        var elm = this;
        if (_uiView2.default.hasDataset(el, UIColFix)) return;
        var colfix = new UIColFix({
            el: elm
        }).saveDataset();
        elm.data("api", colfix);
    });
};